<template>
	<!--弹窗-->
	<div class="yidialog-con" id="Dia">
		<div class="yid-con flex-row yid-con-col">
			<!-- 弹窗内容	-->
			<div class="reading-day-alert">
				<div class="btn heart-beat">立即参与</div>
				<div class="close"></div>
			</div>
		</div>
	</div>
	<div id="readingDayFloat" class="reading-day-float">
		<img class="img read-float-animate" src="http://static2.61info.com/service/imgs/groupPurchase/act/reading_day/float.png?v=20200418" alt="">
	</div>
	<div id="cardEntry" class="reading-day-card">
		<img src="http://static2.61info.com/service/imgs/groupPurchase/act/reading_day/entry_card.png?v=20200118" alt="">
	</div>
</template>

<script>
	export default {
		data: {
			pageName: $('body').data('page-name'), // inviteFriends  collageDetails
			courseId: +utils.getQueryString('courseId')
		},
		// pvuvkey
		pvuvKeyMap: {
			INDEX_ALERT_EXPOSURE: 1511,
			INDEX_ALERT_CLICK: 1512,
			COURSE_ALERT_EXPOSURE: 1513,
			COURSE_ALERT_CLICK: 1514,
			FLOAT_EXPOSURE: 1515,
			FLOAT_CLICK: 1516,
			CARD_EXPOSURE: 1517,
			CARD_CLICK: 1518
		},
		// 初始化
		init: function () {
			var _this = this;

			_this.request.entry({courseId: _this.data.courseId}, function (res) {
				if (res.resultCode.code == 0) {
					var resData = res.value;
					if (!resData.showEntry) return
					_this.initEntry(resData)
				}
			})

		},
		//
		initEntry: function (resData) {
			var _this = this;
			var pvuvKeyMap = _this.pvuvKeyMap;
			var storageKey = 'reading_day';

			_this.data.pageName == 'courseList' && initFloat();
			_this.data.pageName == 'courseList' && initAlert();
			_this.data.pageName == 'moreCourse' && initAlert();
			_this.data.pageName == 'user' && initCard();

			function initAlert() {
				if (localStorage.getItem(storageKey)) return // 已弹过，不弹
				window.showReadDayAlert = true;
				_this.popupAlert.show('reading-day-alert');
				addPvuv('alert', 'exposure');
				_this.isForbidScroll(true);
				localStorage.setItem(storageKey, storageKey);

				var $alert = _this.popupAlert.get$Dia('reading-day-alert');
				$alert.on('click', function (e) {
					e.stopPropagation();
					_this.isForbidScroll(false);
					_this.popupAlert.hide();
					toAct('alert');
				})
				$alert.on('click', '.close', function (e) {
					e.stopPropagation();
					_this.isForbidScroll(false);
					_this.popupAlert.hide();
				})
			}

			function initFloat() {
				var $float = $(readingDayFloat);
				var changeFloat = Math.random() > .5;
				if (changeFloat) {
					$float.find('.img').attr('src', 'http://static2.61info.com/service/imgs/groupPurchase/act/reading_day/float1.png?v=20200418');
				}
				$('body').append($float);
				addPvuv('float', 'exposure');

				$float.on('click', function () {
					toAct('float');
				})
			}

			function initCard() {
				var $card = $(cardEntry);
				setTimeout(function () {
					$('.surprise_entry').append($card);
					addPvuv('card', 'exposure');
					// $card.insertAfter($('.surprise_entry').children().eq(2))
					$card.on('click', function () {
						toAct('card');
					})
				}, 300)
			}

			function toAct(type) {
				addPvuv(type, 'click', function () {
					location.href = window.actIndependentDomain + '/app/spa/dengta_h5/reading_day/read_course?pageType=send';
				})
			}

			function addPvuv(type, evenType, callback) {
				var pvuvKey = null;
				if (evenType == 'exposure') {
					pvuvKey = type == 'alert'
						? (_this.data.pageName == 'courseList' ? pvuvKeyMap.COURSE_ALERT_EXPOSURE : pvuvKeyMap.INDEX_ALERT_EXPOSURE)
						: type == 'float'
							? pvuvKeyMap.FLOAT_EXPOSURE
							: pvuvKeyMap.CARD_EXPOSURE;
				} else {
					pvuvKey = type == 'alert'
						? (_this.data.pageName == 'courseList' ? pvuvKeyMap.COURSE_ALERT_CLICK : pvuvKeyMap.INDEX_ALERT_CLICK)
						: type == 'float'
							? pvuvKeyMap.FLOAT_CLICK
							: pvuvKeyMap.CARD_CLICK;
				}
				_this.request.addPvuv(pvuvKey, function () {
					callback && callback();
				})
			}
		},
		/**
		 * 弹窗控制器
		 */
		popupAlert: (function () {
			var $Dia = $(Dia);
			$Dia.find('.yid-cls-con').children().hide(); // 刚开始隐藏所有弹窗内容的显示
			var hadInsertBody = false; // 弹窗是否插入body中
			var curType = ''; // 当前弹窗

			function checkHide () {
				// 显示弹窗之前，检查其他弹窗是否关闭
				if (curType) {
					$Dia.hide();
				}
			}

			return {
				getCurType: function () {
					return curType
				},
				/**
				 * 获取弹窗对象
				 * @param className
				 * @returns {*}
				 */
				get$Dia: function (className) {
					return className ? $Dia.find('.' + className) : $Dia;
				},
				/**
				 * 隐藏弹窗
				 * @param callback
				 * @returns {*|jQuery.fn.init|jQuery|HTMLElement}
				 */
				hide: function (callback) {
					$Dia.find('.' + curType).hide();
					$Dia.hide();
					callback && callback();
					return $Dia;
				},
				/**
				 * 显示弹窗
				 * @param className 弹窗的class名称
				 * @param callback
				 * @returns {*|jQuery.fn.init|jQuery|HTMLElement}
				 */
				show: function (className, callback) {
					if (!className) return
					checkHide();
					curType = className;
					$Dia.find('.' + className).show();
					hadInsertBody ? $Dia.show() : ($('body').append($Dia) && (hadInsertBody = true));
					callback && callback();
					return $Dia;
				}
			}
		})(),
		// 禁止滑动
		isForbidScroll: (function () {
			var isForbidScroll = utils.forbidScroll();
			return function (isForbid) {
				isForbidScroll(isForbid)
			}
		})(),
		// 请求
		request: (function () {
			var _request = function (url, data, callback, async) {
				$.ajax({
					url: url,
					data: data,
					async: async,
					success: function (res) {
						callback && callback(res);
					},
					fail: function () {
						ui61.toast('网络异常');
					}
				})
			};

			var actId = '10052';

			return {
				// 获取入口信息
				entry: function (data, callback) {
					_request('/dengta/common/act/' + actId + '/getActEntryInfo.json', data, callback, true)
				},
				/** pvuv统计 */
				addPvuv: function (pvuvKeyId, callback) {
					_request('/dengta/common/act/' + actId + '/addPvuv.json', {pvuvKeyId: pvuvKeyId}, callback, true)
				}
			}
		})()
	}
</script>

<style scoped lang="less">
	@BASE_IMG_URL: 'http://static2.61info.com/service/imgs/groupPurchase/act/reading_day';

	.reading-day-alert {
		position: relative;
		width: 574px;
		height: 628px;
		background: url('@{BASE_IMG_URL}/entry_alert1.png?v=20200418') no-repeat center center / 100%;
		&::before, &::after, .btn {
			content: '';
			position: absolute;
		}
		.btn {
			bottom: -19px;
			left: 50%;
			margin-left: -200px;
			width: 400px;
			height: 90px;
			background-image: linear-gradient(-90deg,
			#ff6a4c 0%,
			#ff957f 100%);
			border-radius: 45px;
			font-size: 36px;
			color: #ffffff;
			text-align: center;
			line-height: 90px;
		}
		@keyframes bookAnimate {
			40% {
				transform: translateY(-50%) rotateY(180deg);
			}
			100% {
				transform: translateY(0) rotateY(0);
			}
		}
		.heart-beat {
			animation: heartBeat 2s infinite;
		}

		@keyframes heartBeat {
			0% {
				-webkit-transform: scale(1);
				transform: scale(1);
			}

			14% {
				-webkit-transform: scale(.9);
				transform: scale(.9);
			}

			28% {
				-webkit-transform: scale(1);
				transform: scale(1);
			}

			42% {
				-webkit-transform: scale(.9);
				transform: scale(.9);
			}

			70% {
				-webkit-transform: scale(1);
				transform: scale(1);
			}
		}

		.close {
			width: 70px;
			height: 70px;
			position: absolute;
			left: 50%;
			transform: translateX(-50%);
			bottom: -90px;
			background: url('@{BASE_IMG_URL}/close.png') no-repeat center center / 42px 42px;
		}
	}

	.reading-day-float {
		position: fixed;
		bottom: 24%;
		right: 39px;
		width: 186px;
		height: 140px;
		.img {
			width: 100%;
			height: 100%;
		}
	}

	.flex-row {
		display: -moz-box;
		/* 老版本语法: Firefox (buggy) */
		display: -ms-flexbox;
		/* 混合版本语法: IE 10 */
		display: -webkit-flex;
		/* 新版本语法: Chrome 21+ */
		display: flex;
	}

	@cl-mask: rgba(0, 0, 0, 0.85);
	/**弹窗**/
	.yidialog-con {
		position: fixed;
		width: 100%;
		height: 100%;
		top: 0px;
		left: 0px;
		display: flex;
		align-items: center;
		justify-content: center;
		z-index: 1000;
		background: @cl-mask;

		.yid-back {
			position: absolute;
			left: 0px;
			top: 0px;
			width: 100%;
			height: 100%;
			text-align: center;
			background: @cl-mask;
		}

		.yid-con {
			position: relative;
			display: flex;
			justify-content: center;
			align-content: center;
			color: #ffffff;
			flex-wrap: wrap;

			.yid-cls {
				position: relative;
				z-index: 9999;
				width: 0.51rem;
				height: 0.51rem;
				flex-shrink: 0;
			}

			.yid-hand {
				position: absolute;
				width: 1rem;
				top: 3.1rem;
				right: 0.1rem;
				animation: handClick 1s infinite;
			}
		}

		.yid-con-col {
			display: flex;
			justify-content: center;
			align-items: center;
			width: 100%;
			height: 100%;
		}
	}

	.read-float-animate {
		animation: readTada 1s infinite;
	}
	@keyframes readTada {
		from {
			-webkit-transform: scale3d(1, 1, 1);
			transform: scale3d(1, 1, 1);
		}

		10%,
		20% {
			-webkit-transform: scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg);
			transform: scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg);
		}

		30%,
		50%,
		70%,
		90% {
			-webkit-transform: scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg);
			transform: scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg);
		}

		40%,
		60%,
		80% {
			-webkit-transform: scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg);
			transform: scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg);
		}

		to {
			-webkit-transform: scale3d(1, 1, 1);
			transform: scale3d(1, 1, 1);
		}
	}
</style>
